#include <vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------

#include "dlgParseBenutzer.h"
//---------------------------------------------------------------------------

#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------

TFormParseBenutzer *FormParseBenutzer;
//---------------------------------------------------------------------------

__fastcall TFormParseBenutzer::TFormParseBenutzer(TComponent* Owner) : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TFormParseBenutzer::btnRegistrierenClick(TObject *Sender)
{
	bool bErfolg = true;
	TJSONObject *pEmail;
	TBackendEntityValue entity;

	// Der Username und das Passwort koennen beim registrieren ganz normal angegeben werden
	// weitere Daten (wie z. B. die E-Mail-Adresse) muessen per JSON uebergeben werden

	// JSON fuer die E-Mail-Adresse basteln
	pEmail = new TJSONObject();
	pEmail->AddPair("email", this->edtEMail->Text);

	// Den User auf Parse anmelden, ueber entity erhaelt man die ObjectID des neuen Users
	try
	{
		this->BackendUsers->Users->SignupUser(this->edtUsername->Text, this->edtPasswort->Text, pEmail, entity);
	}
	catch(EBackendError &exception)
	{
		MessageBoxW(0, exception.Message.c_str(), L"Fehler", MB_ICONERROR | MB_OK);
		bErfolg = false;
	}

	if (bErfolg == true)
		MessageBoxW(0, L"Du hast dich erfolgreich registriert!\r\nBitte besttige als nchstes deine E-Mail-Adresse!", L"Glckwunsch", MB_ICONINFORMATION | MB_OK);

	delete pEmail;
}
//---------------------------------------------------------------------------

void __fastcall TFormParseBenutzer::btnLoginClick(TObject *Sender)
{
	bool bErfolg = true, bEMailVerifiziert;
	String strSessionToken;
	TBackendEntityValue entity;
	TJSONArray *pUser;

	// Das JSON-Array erzeugen
	pUser = new TJSONArray();

	// Den User einloggen
	try
	{
		this->BackendUsers->Users->LoginUser(this->edtUsernameLogin->Text, this->edtPasswortLogin->Text, entity, pUser);
	}
	catch(EBackendError &exception)
	{
		MessageBoxW(0, exception.Message.c_str(), L"Fehler", MB_ICONERROR | MB_OK);
		bErfolg = false;
	}

	if (bErfolg == true)
	{
		// Pruefen ob die E-Mail verifiziert ist
		if (static_cast<TJSONObject*>(pUser->Items[0])->GetValue("emailVerified")->Value() == "true")
			bEMailVerifiziert = true;
		else
			bEMailVerifiziert = false;

		// Falls die E-Mail-Adresse noch nicht bestaetigt wurde -> Meldung
		if (bEMailVerifiziert == false)
		{
			MessageBoxW(0, L"Bitte besttige zuerst deine E-Mail-Adresse!", L"Achtung", MB_ICONINFORMATION | MB_OK);
			this->BackendUsers->Users->Logout();
		}
		else
		{
			// Session-Token
			strSessionToken = static_cast<TJSONObject*>(pUser->Items[0])->GetValue("sessionToken")->Value();

			// Irgendwas machen

			// Ausloggen
			this->BackendUsers->Users->Logout();
		}
	}
}
//---------------------------------------------------------------------------
